//+------------------------------------------------------------------+
//|                                                       eugenk.mq4 |
//|                                                         |
//|                                         WPR granit77 |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""
#property show_inputs

//,     
//    \expert\files

extern string Filename="planimetry_WPR.tpl"; // ,     \expert\files
                                             //      metatrader\templates      
//,   
extern int N=200;      // 
extern int Min=20;      // 
extern int Max=3000;    //  ( Step  0,    )
extern int Step=10;     // 0,       in  Max, N . 
                        //  0,    Min   Step
extern color Color=0;  //  (R=G=B=0),  .   

// 
string Name="Williams' Percent Range"; // 
int rainbow[10000];  //  
int nRainbow;        //  

int GetRGB(int r, int g, int b)
{//    r, g, b
   return (256*(256*b + g) + r);
}

int BuildRainbow()
{// ,   
//      :)
   int r=255, g=0, b=0;
   int n=0;
   
   while(g !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      g++; n++;
   }   
   while(r !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      r--; n++;
   }
   while(b !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      b++; n++;
   }
   while(g !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      g--; n++;
   }
   while(r !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      r++; n++;
   }
   return (n);   
}

int GetRainbowColor(int c)
{//    
   double k=nRainbow/N;
   int n=c*k;
   return (rainbow[n]);
}



void PlaceYourOwn(int f, int p, int c)
{
   string s;
   s="<indicator>";     FileWrite(f, s);       
   s="name="+Name;      FileWrite(f, s);
   s="period="+p;       FileWrite(f, s);
   s="color="+c;        FileWrite(f, s);      
   s="style=0";         FileWrite(f, s);
   s="weigth=1";        FileWrite(f, s);
   //if(p<=Min)
   //{
   s="min=-100.000000";       FileWrite(f, s);
   s="max=0.000000";          FileWrite(f, s);
   s="levels_color=12632256"; FileWrite(f, s);
   s="levels_style=2";        FileWrite(f, s);
   s="levels_weight=1";       FileWrite(f, s);
   s="level_0=-80.0000";      FileWrite(f, s);
   s="level_1=-20.0000";      FileWrite(f, s);   
   //}
   s="period_flags=0";  FileWrite(f, s);
   s="show_data=1";     FileWrite(f, s);   
   s="</indicator>";    FileWrite(f, s);   
}

int start()
{
   int c;      //
   int p;      //
   int f;      //
   double s;   // 
   
   s=(Max-Min); s/=N;
   nRainbow=BuildRainbow();
   if(Step!=0) s=Step;
   f=FileOpen(Filename, FILE_WRITE);

   
   FileWrite(f, "<chart>");
   FileWrite(f, "<window>");
   FileWrite(f,"<indicator>");
   FileWrite(f,"name=main");
   FileWrite(f,"</indicator>");
   FileWrite(f, "</window>");   
   FileWrite(f, "<window>");  
   for(int i=0; i<N; i++)
   {
      p=Min+s*i;
      if(Color==0) c=GetRainbowColor(i); else c=Color;
      PlaceYourOwn(f,p,c);
   }
   
   FileWrite(f, "</window>");   
   FileWrite(f, "</chart>");
   FileClose(f);   
   return(0);
}
//----------
//----------